/////////////////////////////////////////////////////////////////////////
//
// CDockingWnd            
//
// Created: Mar 12, 2001
// Last Modified: August 03, 2000
//
/////////////////////////////////////////////////////////////////////////
// Copyright (C) 2001 by Greg Winkler, Intelligent Systems Inc.
// (docking_windows@intelligentsystems.net)
//
// All rights reserved.
//
// This code is free for personal and commercial use, providing this 
// notice remains intact in the source files and all eventual changes are
// clearly marked with comments.
//
// You must obtain the author's consent before you can include this code
// in a software library.
//
// No warrantee of any kind, express or implied, is included with this
// software; use at your own risk, responsibility for damages (if any) to
// anyone resulting from the use of this software rests entirely with the
// user.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc. for
// the docking window code to cristi@datamekanix.com or post them 
// at the message board at the site.
//
// Send bug reports, bug fixes, enhancements, requests, flames, etc. for
// this code to docking_windows@intelligentsystems.net.
//
/////////////////////////////////////////////////////////////////////////
/*///////////////////////////////////////////////////////////////////////

    Description:

    This is a modified version of the CDockingWnd code from Cristi Posea's 
    sample code.

    He asked me if I could get the docking window code to contain
    an ActiveX control, so I tweaked his code so that you can now embed
    a control (I used ActiveMovie) into a docking 
    window you can tear out of the containing control.
    
/*///////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DockingWnd.h"
#include ".\resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CDockingWnd

CDockingWnd::CDockingWnd()
{
}

CDockingWnd::~CDockingWnd()
{
}


BEGIN_MESSAGE_MAP(CDockingWnd, baseCDockingWnd)
	//{{AFX_MSG_MAP(CDockingWnd)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
/// Declare all the stuff you need if you're using the ActiveMovie control
/////////////////////////////////////////////////////////////////////////////
#ifdef _USE_ACTIVE_MOVIE_CTRL_

BEGIN_EVENTSINK_MAP(CDockingWnd, baseCDockingWnd)
    //{{AFX_EVENTSINK_MAP(CDockingWnd)
   ON_EVENT(CDockingWnd, IDC_ACTIVE_MOVIE_CTRL, DISPID_READYSTATECHANGE /* ReadyState */, OnReadyStateChange, VTS_I4 )
   //}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

/*////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    METHOD:	    void CDockingWnd::OnReadyStateChange( MPReadyStateConstants p_iState )

    PURPOSE:    When you load a file into the ActiveMovie control, it 
                can take a while. You can't just call 'Open()', then 'Play()',
                b/c the Open() call is asynchronous. (If you're loading a 
                movie across the internet, you can understand that it could 
                take a LONG time). 
                
                The control fire events to the container to tell it when it's
                ready for playing. When the control says the file has loaded,
                I call Play().

    PARAMETERS:	MPReadyStateConstants   p_iState - current state

    RETURNS:    None

//////////////////////////////////////////////////////////////////////////////
/*////////////////////////////////////////////////////////////////////////////
void CDockingWnd::OnReadyStateChange( MPReadyStateConstants p_iState )
{
    if( m_pMediaPlayer )
    {
        if( mpReadyStateComplete == p_iState ) /// load complete
            m_pMediaPlayer->Play();
    }
}

#endif  // #ifdef _USE_ACTIVE_MOVIE_CTRL_




/*////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

    METHOD:	    int CDockingWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 

    PURPOSE:    WM_CREATE handler 

    PARAMETERS: LPCREATESTRUCT lpCreateStruct - ptr to CREATESTRUCT 

    RETURNS:    < 0 if creation unsuccessful

//////////////////////////////////////////////////////////////////////////////
/*////////////////////////////////////////////////////////////////////////////
int CDockingWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (baseCDockingWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetSCBStyle(GetSCBStyle() | SCBS_SHOWEDGES | SCBS_SIZECHILD);
   // SetSCBStyle(GetSCBStyle() | SCBS_SIZECHILD);
    
#ifdef _USE_EDIT_CTRL_  

    if (!m_wndChild.Create( WS_CHILD | WS_VISIBLE | 
			                ES_MULTILINE | ES_WANTRETURN | ES_AUTOVSCROLL,
		                    CRect(0,0,0,0), 
                            this, 
                            IDC_FRAME_EDIT ) )
		return -1;
	m_wndChild.ModifyStyleEx(0, WS_EX_CLIENTEDGE);

    /////////////////////////////////////////////////////////////////////////
	/// older versions of Windows* (NT 3.51 for instance)
	/// fail with DEFAULT_GUI_FONT
    /////////////////////////////////////////////////////////////////////////
	if (!m_font.CreateStockObject(DEFAULT_GUI_FONT))
		if (!m_font.CreatePointFont(80, "MS Sans Serif"))
			return -1;

	m_wndChild.SetFont(&m_font);

    m_wndChild.SetWindowText( _T( "This docking window is embedded in the control" ) );

#else  //  _USE_ACTIVE_MOVIE_CTRL_

    /////////////////////////////////////////////////////////////////////////
    /// You need the following call to allow your control to contain 
    /// other controls, like the ActiveMovie control. This is the secret
    /// to getting the docking windows to contain ActiveX controls. The
    /// rest is easy...
    /////////////////////////////////////////////////////////////////////////
    AfxEnableControlContainer();


    /////////////////////////////////////////////////////////////////////////
    /// Actually get the CWnd object to instantiate an active movie control
    /// for you
    /////////////////////////////////////////////////////////////////////////
    if( !m_AMControl.CreateControl( _T("AMOVIE.ActiveMovie Control.2"), 
                                    _T("Active Movie Ctrl"), 
                                    WS_CHILD | WS_VISIBLE, 
                                    CRect(0,0, 50, 50),
                                    this, 
                                    IDC_ACTIVE_MOVIE_CTRL     ) )
    {
        TRACE(  "Unable to create Active Movie control. "
                "GetLastError() == %d\n", GetLastError()    );

        return -1;
    }

    /////////////////////////////////////////////////////////////////////////
    /// Get the IUnknown of the control so I can QI the IMediaPlayer
    /// interface. See MSDXM.TLH for the interface definition.
    /////////////////////////////////////////////////////////////////////////
    IUnknownPtr pUnk = m_AMControl.GetControlUnknown();
    if( pUnk )
    {
        pUnk->QueryInterface( IID_IMediaPlayer, (void**)&m_pMediaPlayer );

        /////////////////////////////////////////////////////////////////////
        /// If the QI worked
        /////////////////////////////////////////////////////////////////////
        if( m_pMediaPlayer )
        {
            /////////////////////////////////////////////////////////////////
            /// Try to open a sample file. This could be a URL on the web.
			/// I tested it with some movie of my little girl...
            /////////////////////////////////////////////////////////////////
            /*
			if( SUCCEEDED( m_pMediaPlayer->Open( L".\\brianna.mpg" ) ) )
            {         
                m_pMediaPlayer->put_EnableContextMenu( TRUE );
            }
			*/
        }
    }

#endif      // _USE_ACTIVE_MOVIE_CTRL_


    return 0;
}

